Bug 903731 - yum upgrade protected multilib packages
yum upgrade protected multilib packages
Status: CLOSED NOTABUG
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: yum (Show other bugs)
7.0
Unspecified Unspecified
medium Severity medium
: rc
: ---
Assigned To: James Antill
BaseOS QE Security Team
: Regression
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-01-24 11:58 EST by Patrik Kis
Modified: 2014-01-21 01:25 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-18 15:24:56 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Patrik Kis 2013-01-24 11:58:59 EST
+++ This bug was initially created as a clone of Bug #840543 +++

Description of problem:
When multilib packages are upgraded and only one arch is available yum suppose to fail and keep the old packages.
This is the behavior on RHEL-6 but on RHEL-7 it proceed with upgrade.

Version-Release number of selected component (if applicable):
yum-3.4.3-47.el7.noarch

How reproducible:
100%

Steps to Reproduce:
1/ Create test packages or find some similar in repos:
pkg-1.i686.rpm
pkg-1.x86_64.rpm
pkg-2.i686.rpm
pkg-2.x86_64.rpm
2/ Install the version 1:
# yum install pkg-1.i686.rpm pkg-1.x86_64.rpm
3/ Update only one architecture:
# yum localupdate pkg-2.x86_64.rpm

Actual results:
yum proceed with update and uninstall the version 1 packages and install the
available verion 2:
# rpm -qa pkg
pkg-2.x86_64

Expected results:
yum report error like in RHEL-6:
...
 You could try using --skip-broken to work around the problem
 You could try running: rpm -Va --nofiles --nodigest
error.log:
Error:  Multilib version problems found. This often means that the root
       cause is something else and multilib version checking is just
       pointing out that there is a problem. Eg.:
       
         1. You have an upgrade for pkg which is missing some
            dependency that another package requires. Yum is trying to
            solve this by installing an older version of pkg of the
            different architecture. If you exclude the bad architecture
            yum will tell you what the root cause is (which package
            requires what). You can try redoing the upgrade with
            --exclude pkg.otherarch ... this should give you an error
            message showing the root cause of the problem.
       
         2. You have multiple architectures of pkg installed, but
            yum can only see an upgrade for one of those arcitectures.
            If you don't want/need both architectures anymore then you
            can remove the one with the missing update and everything
            will work.
       
         3. You have duplicate versions of pkg installed already.
            You can use "yum check" to get yum show these errors.
       
       ...you can also use --setopt=protected_multilib=false to remove
       this checking, however this is almost never the correct thing to
       do as something else is very likely to go wrong (often causing
       much more problems).
       
       Protected multilib versions: pkg-2.x86_64 != pkg-1.i686

# rpm -q pkg
pkg-1.i686.
pkg-1.x86_64
Comment 3 James Antill 2013-06-18 15:24:56 EDT
> Actual results:
> yum proceed with update and uninstall the version 1 packages and install the available verion 2:
> # rpm -qa pkg
> pkg-2.x86_64

This is kind of different, in that when using "localupgrade" yum only sees the .x86_64 package, so it's assuming an arch. merge has happened and removes the .i686 package. This wouldn't be the case if both the .i686 and .x86_64 packages were in a repo.
Given that there is no old pkg-1.i686 left after the transaction, there is nothing for multilib_protection to complain about.

Note You need to log in before you can comment on or make changes to this bug.